import es, popuplib, services, langlib

script = __name__.rsplit('.',1)[0].replace('.', '/')

severVars = ['deathmatch_spawn_protection','deathmatch_menu_enable','deathmatch_noblock']
Master = es.import_addon('deathmatch')


class adminMenu:
    def __init__(self, userid):
        self.userid = userid
        sicdm_adminmenu = popuplib.easymenu('player_list', '_popup_choice', self.settingSelected)
        sicdm_adminmenu.settitle('Deathmatch Admin')
        #es.msg(Master.deathmatch_spawn_protection)
        if Master.deathmatch_spawn_protection:
            sicdm_adminmenu.addoption("sp", "Spawn Protection *ON*")
        else:
            sicdm_adminmenu.addoption("sp", "Spawn Protection *OFF*")
        if Master.deathmatch_menu_enable:
            sicdm_adminmenu.addoption("gm", "Guns menu *ON*")
        else:
            sicdm_adminmenu.addoption("gm", "Guns menu *OFF*")
        if Master.deathmatch_noblock:
            sicdm_adminmenu.addoption("nb", "Noblock *ON*")
        else:
            sicdm_adminmenu.addoption("nb", "Noblock *OFF*")
        sicdm_adminmenu.send(self.userid)
    def settingSelected(self, userid, cmd, sicdm_adminmenu):
        es.tell(userid, '#multi', text("recommend"))
        if cmd == 'sp':
            if Master.deathmatch_spawn_protection:
                Master.deathmatch_spawn_protection.set(0)
                es.msg('#multi', text("spawn unload"))
            else:
                Master.deathmatch_spawn_protection.set(1)
                es.msg('#multi', text("spawn load"))
        elif cmd == 'gm':
              if Master.deathmatch_menu_enable:
                  Master.deathmatch_menu_enable.set(0)
                  es.msg('#multi', text("gun menu disable"))
              else:
                  Master.deathmatch_menu_enable.set(1)
                  es.msg('#multi', text("gun menu enabled"))
        elif cmd == 'nb':
              if Master.deathmatch_noblock:
                  Master.deathmatch_noblock.set(0)
                  es.msg('#multi', text("noblock disable"))
              else:
                  Master.deathmatch_noblock.set(1)
                  es.msg('#multi', text("noblock enable"))
        adminMenu(userid)

def load():
    global text
    setup_auth()
    text = langlib.Strings(es.getAddonPath("deathmatch") + "/strings.ini")
    if not es.exists('command', '!sicdm'):
        es.regsaycmd('!sicdm', '%s/checkAuth' % script)

def unload():
    if es.exists('command', '!sicadmin'):
        es.unregsaycmd('!sicadmin')

def checkAuth():
    userid = str(es.getcmduserid())
    if isAuthed(userid):
        adminMenu(userid)
        es.msg('sent')
    else:
        es.tell(userid, '#multi','#greenYou are not authorized to run this command')

def setup_auth():
    global isAuthed
    if services.isRegistered('auth'):
        auth_service = services.use('auth')
        auth_service.registerCapability('deathmatch_admin', auth_service.ADMIN)
        isAuthed = lambda x: auth_service.isUseridAuthorized(x, 'deathmatch_admin')
    else:
        isAuthed = lambda x: False